let read filename =
 let chin = open_in filename in
 (* collect the characters of input in [acc] *)
 let rec read acc = function
  | 0 -> acc
  | n -> read (input_char chin::acc) (n - 1)
 in
 let result = read [] (in_channel_length chin) in
 close_in chin;
 (* [result] contains the contents of the file in reverse order *)
 Lst.rev result

let write filename cs =
 let chout = open_out filename in
 let rec write = function
  | [] -> close_out chout
  | c::cs -> output_char chout c; write cs
 in
 write cs
